CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency

  N_S = "N"
  E_W = "E"
  million = 1_000_000
  NL=13 ' new line

VAR
long tic, toc, tac, us
long lat[12]
long lon[12]
long speed[3]
long heading[4]
long d_xte, vmg, dist, angle_tt, ttt,tmp, tmp2
long convert_us
long angle

OBJ  'Objects Section
    trig : "trig functions spin v0.4"
    dbg  : "parallax serial terminal"
    

pub main|i,j
 i:=0
 convert_us:=clkfreq/million

 dbg.start(57600)
 waitcnt(clkfreq*5+cnt)
 dbg.charin

 ' first part, string parsing
 dbg.str(string("string parse:"))
 dbg.char(NL)
 dbg.str(string("----------------"))
 dbg.char(NL)
 dbg.str(string("-   LAT        -"))
 dbg.char(NL)

 tic:=cnt
 tmp:=trig.parselat(@testlat0,N_S)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselat(@testlat1,N_S)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselat(@testlat2,N_S)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselat(@testlat3,N_S)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselat(@testlat4,N_S)
 toc:=cnt
 scrivirisulatitest

 dbg.str(string("-   LONG       -"))
 dbg.char(NL)

 tic:=cnt
 tmp:=trig.parselong(@testlong0,E_W)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselong(@testlong1,E_W)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselong(@testlong2,E_W)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselong(@testlong3,E_W)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parselong(@testlong4,E_W)
 toc:=cnt
 scrivirisulatitest

 dbg.str(string("-   SPEED      -"))
 dbg.char(NL)
 tic:=cnt
 tmp:=trig.parsespeed(@testspeed0)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parsespeed(@testspeed1)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parsespeed(@testspeed2)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parsespeed(@testspeed3)
 toc:=cnt
 scrivirisulatitest
 tic:=cnt
 tmp:=trig.parsespeed(@testspeed4)
 toc:=cnt
 scrivirisulatitest

 dbg.str(string("-   HEAD       -"))
 dbg.char(NL)
 tic:=cnt
 tmp:=trig.parsespeed(@testhead0)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead0)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead1)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead1)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead2)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead2)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead3)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead3)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead4)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead4)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead5)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead5)
 tac:=cnt
 scrivirisulatitest2

 tic:=cnt
 tmp:=trig.parsespeed(@testhead6)
 toc:=cnt
 tmp2:=trig.parseheading(@testhead6)
 tac:=cnt
 scrivirisulatitest2

 ' second part, tri calculus
 dbg.str(string("---------------------"))
 dbg.char(NL)
 dbg.str(string("load data - press key"))
 dbg.char(NL)
 dbg.str(string("---------------------"))
 dbg.char(NL)
 dbg.charin
 load_data
 printdata
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("data loaded - press key"))
 dbg.char(NL)
 dbg.str(string("To have angle-distance "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 ' starting from point 12, check angle and distance to points 1..11
 i:=0
 repeat 11
   tic:=cnt
   'j:=trig.deltalong(lat[11],lat[i],lon[11],lon[i])
   'angle:=trig.atan2(lat[i]-lat[11],j)
   angle:=trig.angletotarget(lat[11],lon[11],lat[i],lon[i])
   dist:=trig.disttotarget
   toc:=cnt
   print_heading(i)
   i++


 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("VMG - press key        "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To point 1:            "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 VMG_TTT(0)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To point 4:            "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 VMG_TTT(3)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To point 6:            "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 VMG_TTT(5)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To point 7:            "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 VMG_TTT(6)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To point 11:            "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 VMG_TTT(10)

 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("XTE from point 12      "))
 dbg.char(NL)
 dbg.str(string("      press key        "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)


 dbg.str(string("To line 1 2:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(1,0)
 XTE(0,1)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 1 3:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(2,0)
 XTE(0,2)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 1 5:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(4,0)
 XTE(0,4)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 10 11:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(10,9)
 XTE(9,10)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 9 10:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(9,8)
 XTE(8,9)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 9 11:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(10,8)
 XTE(8,10)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 dbg.str(string("To line 4 1:           "))
 dbg.char(NL)
 dbg.str(string("-----------------------"))
 dbg.char(NL)
 XTE(1,3)
 XTE(3,1)

 

pub XTE(wp1,wp2)|i,j
  tic:=cnt
  d_xte:=trig.tometers(trig.xte(lat[11],lon[11],lat[wp1],lon[wp1],lat[wp2],lon[wp2]))
  toc:=cnt
  dbg.dec(d_xte)
  us := (toc-tic)/ convert_us
  dbg.str(string(" time: "))
  dbg.dec(us)
  dbg.char(NL)



pub VMG_TTT(WP)|i,j

 repeat 4
    j:=0
    repeat 3

      tic:=cnt
      angle:=trig.angletotarget(lat[11],lon[11],lat[WP],lon[WP])
      dist:=trig.disttotarget
      vmg:=trig.vmg(speed[j],heading[i],angle)
      ttt:=trig.timetotarget(vmg,dist)
      toc:=cnt
      dbg.str(string("Speed: "))
      dbg.dec(speed[j])
      dbg.str(string(" heading: "))
      dbg.dec(heading[i])
      dbg.str(string(" distance: "))
      dbg.dec(dist)
      dbg.str(string(" VMG: "))
      dbg.dec(vmg)
      dbg.str(string(" TTT: "))
      dbg.dec(ttt)
      us := (toc-tic)/ convert_us
      dbg.str(string(" time: "))
      dbg.dec(us)
      dbg.char(NL)
      j++
    i++  
      




pub print_heading(counter)
us := (toc-tic)/ convert_us
dbg.str(string("To point: "))
dbg.dec(counter)
dbg.str(string(" angle: "))
dbg.dec(trig.todegrees(angle))
dbg.str(string(" D: "))
dbg.dec(dist)
dbg.str(string(" time: "))
dbg.dec(us)
dbg.str(string(" us->"))
dbg.dec(toc-tic)
dbg.str(string(" cnt"))

dbg.char(NL)


pub printdata|i 'prints data from converted arrays

i:=0
   repeat 12
     dbg.dec(i)
     dbg.str(string(" "))
     dbg.dec(lat[i])
     dbg.str(string(" "))
     dbg.dec(lon[i])
     dbg.char(13)
     i++

i:=0
   repeat 3
     dbg.dec(i)
     dbg.str(string(" "))
     dbg.dec(speed[i])
     dbg.char(13)
     i++

i:=0
   repeat 4
     dbg.dec(i)
     dbg.str(string(" "))
     dbg.dec(heading[i])
     dbg.char(13)
     i++




pub load_data|i
i:=0
   repeat 12
     lat[i]:=trig.parselat(@lat1[i*11],N_S)
     lon[i]:=trig.parselong(@long1[i*12],E_W)
     i++

i:=0
   repeat 3
     speed[i]:=trig.parsespeed(@speed1[i*3])
     i++

i:=0
   repeat 4
     heading[i]:=trig.parseheading(@head1[i*4])
     i++


pub  scrivirisulatitest
us := (toc-tic)/ convert_us
dbg.str(string("out: "))
dbg.dec(tmp)
dbg.str(string(" T: "))
dbg.dec(us)
dbg.str(string(" us->"))
dbg.dec(toc-tic)
dbg.str(string(" cnt"))

dbg.char(NL)


pub  scrivirisulatitest2
us := (toc-tic)/ convert_us
dbg.str(string("out: "))
dbg.dec(tmp)
dbg.str(string(" T: "))
dbg.dec(us)
dbg.str(string(" us"))

us := (tac-toc)*us/clkfreq
dbg.str(string("  13bit: "))
dbg.dec(tmp2)
dbg.str(string(" T: "))
dbg.dec(us)
dbg.str(string(" us"))
dbg.char(NL)


DAT
' contiene le stringhe per le conversioni
testlat0 byte "4510.1234",0
testlat1 byte "4510.123",0
testlat2 byte "4510.1",0
testlat3 byte "4510.12",0
testlat4 byte "4510.12345678",0
testlong0 byte "11210.123",0
testlong1 byte "11210.1234",0
testlong2 byte "11210.1",0
testlong3 byte "11210.12",0
testlong4 byte "11210.12345678",0

testspeed0 byte "1",0
testspeed1 byte "13",0
testspeed2 byte "13.",0
testspeed3 byte "13.12",0
testspeed4 byte "1.123456",0

testhead0  byte "90",0
testhead1  byte "90.",0
testhead2  byte "90.1234",0
testhead3  byte "290",0
testhead4  byte "290.",0
testhead5  byte "290.1234",0
testhead6  byte "2.1234",0

lat1  byte "4552.56114",0
lat2  byte "4547.23548",0
lat3  byte "4534.19172",0
lat4  byte "4526.99802",0
lat5  byte "4530.42282",0
lat6  byte "4529.45598",0
lat7  byte "4534.30644",0
lat8  byte "4536.64578",0
lat9  byte "4535.82120",0
lat10 byte "4535.77644",0
lat11 byte "4535.65614",0
lat12 byte "4535.70738",0

long1  byte "01050.81622",0
long2  byte "01048.80070",0
long3  byte "01040.32882",0
long4  byte "01041.31198",0
long5  byte "01036.44520",0
long6  byte "01032.70900",0
long7  byte "01033.51198",0
long8  byte "01034.42782",0
long9  byte "01036.07860",0
long10 byte "01036.20052",0
long11 byte "01036.18540",0
long12 byte "01036.07338",0

speed1 byte "01",0
speed2 byte "05",0
speed3 byte "10",0

head1  byte "020",0
head2  byte "150",0
head3  byte "220",0
head4  byte "310",0
